import java.awt.*;
import java.awt.geom.*;
import java.awt.color.*;
import java.awt.image.*;
import java.io.*;

import com.sun.image.codec.jpeg.*;

public class InvertJpeg extends Frame {

  public static void main(String[] args)  throws Exception {
	if (args.length != 1) {
		System.out.println("Usage: java InvertJpeg " +
			"input_image_filename");
		System.exit(-1);
	}
    Frame f = new InvertJpeg(args[0]);
    f.setSize(mImage.getWidth(), mImage.getHeight());
    f.setLocation(200, 200);
    f.setVisible(true);
  }
  
  private static BufferedImage mImage;
  
  public InvertJpeg(String filename)
      throws IOException, ImageFormatException {
    // Load the specified JPEG file.
    InputStream in = new FileInputStream(filename);
    JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);
    mImage = decoder.decodeAsBufferedImage();
    in.close();
  }
  
  public void paint(Graphics g) {
    Graphics2D g2 = (Graphics2D)g;
    short[] invert = new short[256];
    for (int i = 0; i < 256; i++)
      invert[i] = (short)(255 - i);
    LookupTable table = new ShortLookupTable(0, invert);
    LookupOp invertOp = new LookupOp(table, null);
    g2.drawImage(mImage, invertOp, 0, 0);
  }
}


