import java.awt.*;
import java.awt.geom.*;
import java.awt.color.*;
import java.awt.image.*;
import java.io.*;

import com.sun.image.codec.jpeg.*;

public class RedInvertJpeg extends Frame {

  public static void main(String[] args)  throws Exception {
	if (args.length != 1) {
		System.out.println("Usage: java RedInvertJpeg " +
			"input_image_filename");
		System.exit(-1);
	}
    Frame f = new RedInvertJpeg(args[0]);
    f.setSize(mImage.getWidth(), mImage.getHeight());
    f.setLocation(200, 200);
    f.setVisible(true);
  }
  
  private static BufferedImage mImage;
  
  public RedInvertJpeg(String filename)
      throws IOException, ImageFormatException {
    // Load the specified JPEG file.
    InputStream in = new FileInputStream(filename);
    JPEGImageDecoder decoder = JPEGCodec.createJPEGDecoder(in);
    mImage = decoder.decodeAsBufferedImage();
    in.close();
  }
  
  public void paint(Graphics g) {
    Graphics2D g2 = (Graphics2D)g;
	short[] invert = new short[256];
	short[] straight = new short[256];
	for (int i = 0; i < 256; i++) {
		invert[i] = (short)(255 - i);
		straight[i] = (short)i;
	}
	short[][] redInvert = {invert, straight, straight};
	LookupTable table = new ShortLookupTable(0, redInvert);
	LookupOp redInvertOp = new LookupOp(table, null);
    g2.drawImage(mImage, redInvertOp, 0, 0);
  }
}


